'
'  RSERVER.INC
'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

'
'  Constants
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%TCP_CONNECT               = %WM_USER + 4093
%DEFAULT_PORT              = 12069     'port
%MAX_CONNECTIONS           = 1000      'max simultaneous connections
%MAX_IP_WAIT               = 5         'home many tcp interfaces can we listen on
%TCP_TIMEOUT               = 10000     'how long before tcp timeout   
%CLEANUP_TIMER_INTERVAL    = 2000      'how often to call the thread cleanup (milliseconds)

%BTS_MAX_LENGTH            =  1024
%INVALID_COMMAND           = -2000

%RSERVER_OPEN_FILE         = 1
%RSERVER_CLOSE_FILE        = 2
%RSERVER_GET               = 3
%RSERVER_PUT               = 4
%RSERVER_SEEK              = 5
%RSERVER_LOF               = 6
%RSERVER_QUIT              = 99

'
'  Structures
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Type XFER_BUFFER_TYPE
   iCommand As Long           'Used only when sending to the server
   iResult as Long            'Used only when receiving from the server
   iFile As Long              'File handle
   iEncrypted as Long         'Is data buffer encrypted (not yet implemented)
   iCompressed as Long        'Is data buffer compressed (not yet implemented)
   iDataLen As Long           'variable length data size
   iCheckSum as Long          'checksum of this structure
   iDataCS as Long            'checksum of variable length data
End Type


